// package eindopdracht;

public class TestVervulbaar {
  public static void main(String[] args) {
    Formule[] formules = new Formule[12];
    String[] declaraties = new String[12];
    formules[0] = new Exof(new Onwaar(),new Niet(new En(new Of(new Waar(), new Atoom(1)),new Alsdan(new Atoom(2),new Desda(new Atoom(2),new Waar())))));
    declaraties[0] = "uvb   Exof(new Onwaar(),new Niet(new En(new Of(new Waar(), new Atoom(1)),new Alsdan(new Atoom(2),new Desda(new Atoom(2),new Waar())))))";
    formules[1] = new Desda(new Niet(new Atoom(1)),new Atoom(2));// new Waar(); 
    declaraties[1] = "1     Waar()";
    formules[2] = new Onwaar(); 
    declaraties[2] = "0     Onwaar()";
    formules[3] = new Niet(new Atoom(65));
    declaraties[3] = "s65   Atoom(65)";
    formules[4] = new Alsdan(new Atoom(1),new Alsdan(new Atoom(2),new Atoom(1)));
    declaraties[4] = "1trs  Alsdan(new Atoom(1),new Alsdan(new Atoom(2),new Atoom(1)))";
    formules[5] = new Exof(new En(new Atoom(1),new Atoom(2)),new En(new Atoom(1),new Atoom(2)));
    declaraties[5] = "0ide2 Exof(new En(new Atoom(1),new Atoom(2)),new En(new Atoom(1),new Atoom(2)))";   
    formules[6] = new Exof(new Atoom(1),new Atoom(1));
    declaraties[6] = "0ide1 Exof(new Atoom(1),new Atoom(1));";   
    formules[7] = new Exof(new Atoom(1),new Exof(new Atoom(1),new Atoom(34)));
    declaraties[7] = "sass1 Exof(new Atoom(1),new Exof(new Atoom(1),new Atoom(34)))";   
    formules[8] = new En(new Waar(),new Atoom(1));
    declaraties[8] = "scom1 En(new Waar(),new Atoom(1))";   
    formules[9] = new Exof(new Atoom(1),new Exof(new Atoom(2),new Atoom(1)));
    declaraties[9] = "0mul1 Exof(new Niet(new Atoom(1)),new Exof(new Atoom(2),new Exof(new Atoom(1),new Niet(new Atoom(2)))))"; 
    formules[10] = new Alsdan(new Exof(new Niet(new Exof(new Onwaar(),new Desda(new Waar(),new Waar()))),
                                       new Atoom(1)),new En(new Niet(new Of(new Waar(),new Alsdan(new Waar(),new Atoom(2)))),new Atoom(1)));
    formules[11] = new Exof(new Atoom(1),new Onwaar()); 
    for (int i=0;i<12;i++) {
      System.out.print(formules[i]+" is ");
      int[] bedeling = formules[i].vervulbaar();
      if (bedeling == null) {
        System.out.println("onvervulbaar");
      } else {
        System.out.println("vervulbaar voor de volgende bedeling: ");
        for (int atoom:bedeling) 
          System.out.print(" p"+((atoom < 0) ? -atoom+" = on" : atoom+" = ")+"waar");
        System.out.println();
        System.out.println("De waarheidswaarde onder deze bedeling is: "+formules[i].waarde(bedeling));
      }
      System.out.println("Herbrand normaalvorm "+formules[i].herbrandNormaalvorm());
      System.out.println();
    }
  }
}
