// package eindopdracht;

public class Vervulbaar {
  public static void main(String[] args) {
    Formule[] formules = new Formule[13];
    String[] declaraties = new String[formules.length];
    formules[0] = new Exof(new Onwaar(),new Niet(new En(new Of(new Waar(), new Atoom(1)),new Alsdan(new Atoom(2),new Desda(new Atoom(2),new Waar())))));
    declaraties[0] = "uvb   Exof(new Onwaar(),new Niet(new En(new Of(new Waar(), new Atoom(1)),new Alsdan(new Atoom(2),new Desda(new Atoom(2),new Waar())))))";
    formules[1] = new Waar(); 
    declaraties[1] = "1     Waar()";
    formules[2] = new Onwaar(); 
    declaraties[2] = "0     Onwaar()";
    formules[3] = new Niet(new Atoom(65));
    declaraties[3] = "s65   Atoom(65)";
    formules[4] = new Alsdan(new Atoom(1),new Alsdan(new Atoom(2),new Atoom(1)));
    declaraties[4] = "1trs  Alsdan(new Atoom(1),new Alsdan(new Atoom(2),new Atoom(1)))";
    formules[5] = new Exof(new En(new Atoom(1),new Atoom(2)),new En(new Atoom(1),new Atoom(2)));
    declaraties[5] = "0ide2 Exof(new En(new Atoom(1),new Atoom(2)),new En(new Atoom(1),new Atoom(2)))";   
    formules[6] = new Exof(new Atoom(1),new Atoom(1));
    declaraties[6] = "0ide1 Exof(new Atoom(1),new Atoom(1));";   
    formules[7] = new Exof(new Atoom(1),new Exof(new Atoom(1),new Atoom(3)));
    declaraties[7] = "sass1 Exof(new Atoom(1),new Exof(new Atoom(1),new Atoom(34)))";   
    formules[8] = new En(new Waar(),new Atoom(1));
    declaraties[8] = "scom1 En(new Waar(),new Atoom(1))";   
    formules[9] = new Exof(new Atoom(1),new Exof(new Atoom(2),new Atoom(1)));
    declaraties[9] = "0mul1 Exof(new Niet(new Atoom(1)),new Exof(new Atoom(2),new Exof(new Atoom(1),new Niet(new Atoom(2)))))"; 
    formules[10] = new Alsdan(new Exof(new Niet(new Exof(new Onwaar(),new Desda(new Waar(),new Waar()))),
                                       new Atoom(1)),new En(new Niet(new Of(new Waar(),new Alsdan(new Waar(),new Atoom(2)))),new Atoom(1)));
    formules[11] = new Exof(new Atoom(1),new Onwaar()); 
    int[] bedeling1 = new int[1];
    formules[12] = new Atoom(2);
    bedeling1[0] = -2;
    for (int i=0;i<formules.length;i++) {
      System.out.print("["+i+"] "+formules[i]+" is ");
      int[] bedeling;
      try{ 
        bedeling = formules[i].vervulbaar();
        if (bedeling == null) {
          System.out.println("onvervulbaar");
        } else {
          System.out.print("vervulbaar met bedeling: [");
          int positie=0;
          for (int atoom:bedeling) 
            System.out.print(((positie++==0)?"":",")+"p"+((atoom < 0) ? -atoom+" := on" : atoom+" := ")+"waar");
          System.out.println("] waarheidswaarde: "+formules[i].waarde(bedeling));
        }
      } catch (Exception e) {
        System.out.println("vervulbaarheids exception");
      }
      System.out.print("Herbrand normaalvorm: ");
      try{
        System.out.print(""+formules[i].herbrandNormaalvorm()+" ");
      } catch (Exception e) {
        System.out.print("normaliseer exception ");
      }
      try {
        System.out.print("waarheidswaarde onder [p2 := onwaar] is: ");
        System.out.println(formules[i].waarde(bedeling1));
      } catch (OnvoldoendeBedeling e) {
        System.out.println("onbekend");
      } catch (Exception e) {
        System.out.println("waarde exception");
      }

//      System.out.println();
    }
  }
}
